package com.bzd.web.controller.dtp;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.dtp.SDtpZskcxPharmaceuticalShareService;

import java.util.List;

/**
*
* 药学信息收集分享药学科普表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "dtp/sdtpzskcxpharmaceuticalshare")
public class SDtpZskcxPharmaceuticalShareController extends BaseController {

    // 页面跳转前缀
    private String prefix = "dtp";

    @Autowired
    private SDtpZskcxPharmaceuticalShareService sDtpZskcxPharmaceuticalShareService;

    /**
    * 药学信息收集分享药学科普表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("dtp:dtp:view")
    @GetMapping("/sDtpZskcxPharmaceuticalShareAdd")
    public String add() {
        return prefix + "/SDtpZskcxPharmaceuticalShareAdd";
    }

    /**
    * 药学信息收集分享药学科普表 新增
    *
    * @return
    */
    @Log(title = "药学信息收集分享药学科普表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sDtpZskcxPharmaceuticalShareAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sDtpZskcxPharmaceuticalShareService.addSDtpZskcxPharmaceuticalShare(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 药学信息收集分享药学科普表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("dtp:dtp:view")
    @GetMapping("/sDtpZskcxPharmaceuticalShareView")
    public String sdtpzskcxpharmaceuticalshareListView() {
        return prefix + "/SDtpZskcxPharmaceuticalShareList";
    }

    /**
    * 药学信息收集分享药学科普表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("dtp:dtp:sDtpZskcxPharmaceuticalShareList")
    @PostMapping("/sDtpZskcxPharmaceuticalShareList")
    @ResponseBody
    public TableDataInfo sdtpzskcxpharmaceuticalshareList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sDtpZskcxPharmaceuticalShareService.findSDtpZskcxPharmaceuticalShareList(pd);
        return getDataTable(pageData);
    }

    /**
    * 药学信息收集分享药学科普表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("dtp:dtp:remove")
    @Log(title = "药学信息收集分享药学科普表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sDtpZskcxPharmaceuticalShareRemove")
    @ResponseBody
    public AjaxResult sdtpzskcxpharmaceuticalshareRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sDtpZskcxPharmaceuticalShareService.SDtpZskcxPharmaceuticalShareRemove(pd);
        return toAjax(integer);
    }

    /**
    * 药学信息收集分享药学科普表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("dtp:dtp:edit")
    @GetMapping("/sDtpZskcxPharmaceuticalShareEdit/{id}")
    public String sdtpzskcxpharmaceuticalshareView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sDtpZskcxPharmaceuticalShareService.findSDtpZskcxPharmaceuticalShareList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sdtpzskcxpharmaceuticalsharePageEdit";
        }
        return prefix+ "/sdtpzskcxpharmaceuticalshareEdit";
    }

    /**
    * 药学信息收集分享药学科普表保存修改的数据
    */
    @RequiresPermissions("dtp:dtp:edit")
    @Log(title = "药学信息收集分享药学科普表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sDtpZskcxPharmaceuticalShareEdit")
    @ResponseBody
    public AjaxResult sdtpzskcxpharmaceuticalshareEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sDtpZskcxPharmaceuticalShareService.updateSDtpZskcxPharmaceuticalShare(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sdtpzskcxpharmaceuticalshare with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sdtpzskcxpharmaceuticalshare with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
